﻿Type=Class
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals

	'Variables
		Dim Input                   As JavaObject		
		Dim L_Analog_X              As Float
		Dim L_Analog_Y              As Float
		Dim R_Analog_X              As Float
		Dim R_Analog_Y              As Float
		Dim L_Trigger               As Float
		Dim R_Trigger               As Float
		Dim Btn_Press               As Int
		Dim Dead_Zone               As Float
		Dim Device_Name             As String
		Dim Device_Info             As String
		Dim Descriptor              As String
		Dim Motion_Detected         As Boolean
		Dim Plugged_In              As Boolean
	
	'Axis Constants	
		Dim AXIS_BRAKE       		As Int =  23 	'Axis constant: Brake axis of a motion event.
		Dim AXIS_DISTANCE    		As Int =  24 	'Axis constant: Distance axis of a motion event.
		Dim AXIS_GAS         		As Int =  22 	'Axis constant: Gas axis of a motion event.
		Dim AXIS_GENERIC_1   		As Int =  32 	'Axis constant: Generic 1 axis of a motion event.
		Dim AXIS_GENERIC_10  		As Int =  41 	'Axis constant: Generic 10 axis of a motion event.
		Dim AXIS_GENERIC_11  		As Int =  42 	'Axis constant: Generic 11 axis of a motion event.
		Dim AXIS_GENERIC_12  		As Int =  43 	'Axis constant: Generic 12 axis of a motion event.
		Dim AXIS_GENERIC_13  		As Int =  44 	'Axis constant: Generic 13 axis of a motion event.
		Dim AXIS_GENERIC_14  		As Int =  45 	'Axis constant: Generic 14 axis of a motion event.
		Dim AXIS_GENERIC_15  		As Int =  46 	'Axis constant: Generic 15 axis of a motion event.
		Dim AXIS_GENERIC_16  		As Int =  47 	'Axis constant: Generic 16 axis of a motion event.
		Dim AXIS_GENERIC_2   		As Int =  33 	'Axis constant: Generic 2 axis of a motion event.
		Dim AXIS_GENERIC_3   		As Int =  34 	'Axis constant: Generic 3 axis of a motion event.
		Dim AXIS_GENERIC_4   		As Int =  35 	'Axis constant: Generic 4 axis of a motion event.
		Dim AXIS_GENERIC_5   		As Int =  36 	'Axis constant: Generic 5 axis of a motion event.
		Dim AXIS_GENERIC_6   		As Int =  37 	'Axis constant: Generic 6 axis of a motion event.
		Dim AXIS_GENERIC_7   		As Int =  38 	'Axis constant: Generic 7 axis of a motion event.
		Dim AXIS_GENERIC_8   		As Int =  39 	'Axis constant: Generic 8 axis of a motion event.
		Dim AXIS_GENERIC_9   		As Int =  40 	'Axis constant: Generic 9 axis of a motion event.
		Dim AXIS_HAT_X       		As Int =  15 	'Axis constant: Hat X axis of a motion event.
		Dim AXIS_HAT_Y       		As Int =  16 	'Axis constant: Hat Y axis of a motion event.
		Dim AXIS_HSCROLL     		As Int =  10 	'Axis constant: Horizontal Scroll axis of a motion event.
		Dim AXIS_LTRIGGER    		As Int =  17 	'Axis constant: Left Trigger axis of a motion event.
		Dim AXIS_ORIENTATION 		As Int =   8 	'Axis constant: Orientation axis of a motion event.
		Dim AXIS_PRESSURE    		As Int =   2 	'Axis constant: Pressure axis of a motion event.
		Dim AXIS_RTRIGGER    		As Int =  18 	'Axis constant: Right Trigger axis of a motion event.
		Dim AXIS_RUDDER      		As Int =  20 	'Axis constant: Rudder axis of a motion event.
		Dim AXIS_RX          		As Int =  12 	'Axis constant: X Rotation axis of a motion event.
		Dim AXIS_RY          		As Int =  13 	'Axis constant: Y Rotation axis of a motion event.
		Dim AXIS_RZ          		As Int =  14 	'Axis constant: Z Rotation axis of a motion event.
		Dim AXIS_SIZE        		As Int =   3 	'Axis constant: Size axis of a motion event.
		Dim AXIS_THROTTLE    		As Int =  19 	'Axis constant: Throttle axis of a motion event.
		Dim AXIS_TILT        		As Int =  25 	'Axis constant: Tilt axis of a motion event.
		Dim AXIS_TOOL_MAJOR  		As Int =   6 	'Axis constant: ToolMajor axis of a motion event.
		Dim AXIS_TOOL_MINOR  		As Int =   7 	'Axis constant: ToolMinor axis of a motion event.
		Dim AXIS_TOUCH_MAJOR 		As Int =   4 	'Axis constant: TouchMajor axis of a motion event.
		Dim AXIS_TOUCH_MINOR 		As Int =   5 	'Axis constant: TouchMinor axis of a motion event.
		Dim AXIS_VSCROLL     		As Int =   9 	'Axis constant: Vertical Scroll axis of a motion event.
		Dim AXIS_WHEEL       		As Int =  21 	'Axis constant: Wheel axis of a motion event.
		Dim AXIS_X           		As Int =   0 	'Axis constant: X axis of a motion event.
		Dim AXIS_Y           		As Int =   1 	'Axis constant: Y axis of a motion event.
		Dim AXIS_Z           		As Int =  11 	'Axis constant: Z axis of a motion event.
		
	'KeyCode Constants
		Dim KEYCODE_DPAD_CENTER		As Int =  23	'Key code constant: Directional Pad Center key.
		Dim KEYCODE_DPAD_DOWN		As Int =  20	'Key code constant: Directional Pad Down key.
		Dim KEYCODE_DPAD_LEFT		As Int =  21	'Key code constant: Directional Pad Left key.
		Dim KEYCODE_DPAD_RIGHT		As Int =  22	'Key code constant: Directional Pad Right key.
		Dim KEYCODE_DPAD_UP			As Int =  19	'Key code constant: Directional Pad Up key.
		Dim KEYCODE_BUTTON_1		As Int = 188	'Key code constant: Generic Game Pad Button #1.
		Dim KEYCODE_BUTTON_10		As Int = 197	'Key code constant: Generic Game Pad Button #10.
		Dim KEYCODE_BUTTON_11		As Int = 198	'Key code constant: Generic Game Pad Button #11.
		Dim KEYCODE_BUTTON_12		As Int = 199	'Key code constant: Generic Game Pad Button #12.
		Dim KEYCODE_BUTTON_13		As Int = 200	'Key code constant: Generic Game Pad Button #13.
		Dim KEYCODE_BUTTON_14		As Int = 201	'Key code constant: Generic Game Pad Button #14.
		Dim KEYCODE_BUTTON_15		As Int = 202	'Key code constant: Generic Game Pad Button #15.
		Dim KEYCODE_BUTTON_16		As Int = 203	'Key code constant: Generic Game Pad Button #16.
		Dim KEYCODE_BUTTON_2		As Int = 189	'Key code constant: Generic Game Pad Button #2.
		Dim KEYCODE_BUTTON_3		As Int = 190	'Key code constant: Generic Game Pad Button #3.
		Dim KEYCODE_BUTTON_4		As Int = 191	'Key code constant: Generic Game Pad Button #4.
		Dim KEYCODE_BUTTON_5		As Int = 192	'Key code constant: Generic Game Pad Button #5.
		Dim KEYCODE_BUTTON_6		As Int = 193	'Key code constant: Generic Game Pad Button #6.
		Dim KEYCODE_BUTTON_7		As Int = 194	'Key code constant: Generic Game Pad Button #7.
		Dim KEYCODE_BUTTON_8		As Int = 195	'Key code constant: Generic Game Pad Button #8.
		Dim KEYCODE_BUTTON_9		As Int = 196	'Key code constant: Generic Game Pad Button #9.
		Dim KEYCODE_BUTTON_A		As Int =  96	'Key code constant: A Button key.
		Dim KEYCODE_BUTTON_B		As Int =  97	'Key code constant: B Button key.
		Dim KEYCODE_BUTTON_C		As Int =  98	'Key code constant: C Button key.
		Dim KEYCODE_BUTTON_L1		As Int = 102	'Key code constant: L1 Button key.
		Dim KEYCODE_BUTTON_L2		As Int = 104	'Key code constant: L2 Button key.
		Dim KEYCODE_BUTTON_MODE		As Int = 110	'Key code constant: Mode Button key.
		Dim KEYCODE_BUTTON_R1		As Int = 103	'Key code constant: R1 Button key.
		Dim KEYCODE_BUTTON_R2		As Int = 105	'Key code constant: R2 Button key.
		Dim KEYCODE_BUTTON_SELECT	As Int = 109	'Key code constant: Select Button key.
		Dim KEYCODE_BUTTON_START	As Int = 108	'Key code constant: Start Button key.
		Dim KEYCODE_BUTTON_THUMBL	As Int = 106	'Key code constant: Left Thumb Button key.
		Dim KEYCODE_BUTTON_THUMBR	As Int = 107	'Key code constant: Right Thumb Button key.
		Dim KEYCODE_BUTTON_X		As Int =  99	'Key code constant: X Button key.
		Dim KEYCODE_BUTTON_Y		As Int = 100	'Key code constant: Y Button key.
		Dim KEYCODE_BUTTON_Z		As Int = 101	'Key code constant: Z Button key.
		Dim KEYCODE_BUTTON_CROSS	As Int =  96	'Key code constant: CROSS Button key.
		Dim KEYCODE_BUTTON_CIRCLE	As Int =  97	'Key code constant: CIRCLE Button key.		
		Dim KEYCODE_BUTTON_SQUARE	As Int =  99	'Key code constant: SQUARE Button key.
		Dim KEYCODE_BUTTON_TRIANGLE	As Int = 100	'Key code constant: TRIANGLE Button key.

End Sub


'Initializes a GamePad with the specified dead zone for the analog input.
'Example:
'	Dim Player1_Controller as GamePad
'	Dim Player2_Controller as GamePad
'
'	Player1_Controller.Initialize(0, 0.1) 'Initializes Player 1's physical controller (0) with an analog dead zone of 10%
'	Player2_Controller.Initialize(1, 0.1) 'Initializes Player 2's physical controller (1) with an analog dead zone of 10%
Public Sub Initialize(Which_One As Int, DeadZone As Float)
	L_Analog_X      =  0
	L_Analog_Y      =  0
	R_Analog_X      =  0
	R_Analog_Y      =  0
	L_Trigger       =  0
	R_Trigger       =  0
	Btn_Press       = -1
	Dead_Zone       = DeadZone
	Device_Name     = getDeviceName(Which_One, False)
	Device_Info     = ""
	Descriptor      = ""
	Motion_Detected = False
	Plugged_In      = (Device_Name <> "No Gamepad or Joystick detected.")	
End Sub


'Returns the Axis Value (between 0.00 and 1.00), For an analog stick / trigger.
Sub getAxisValue(axis As Int) As Float
	If Abs(Input.RuNMethod("getAxisValue", Array(axis))) >= Dead_Zone Then
		Return Input.RuNMethod("getAxisValue", Array(axis))
	Else
		Return 0
	End If
End Sub


'Returns the full Device Info.
Sub getDeviceInfo As String	
	Return Input.RuNMethod("getDevice", Null)
End Sub


'Returns either the Device Name or Descriptor.
Sub getDeviceName(Index As Int, Device_Descriptor As Boolean) As String
	'Original function code by 'thedesolatesoul'
	'http://www.b4x.com/android/forum/members/thedesolatesoul.11412/
	Dim jo As JavaObject
	jo.InitializeStatic("android.view.InputDevice")
	Dim DeviceIds() As Int = jo.RunMethod("getDeviceIds", Null)		
	Dim Name(DeviceIds.Length - 1) As String
	Dim Desc(DeviceIds.Length - 1) As String
	Dim Device_Index = 0 As Int
	For i = 0 To (DeviceIds.Length - 1)
		Dim joDevice As JavaObject = jo.RunMethodJO("getDevice", Array As Object(DeviceIds(i)))
		Dim sources As Int = joDevice.RunMethod("getSources", Null)
		Log(sources)
		If Bit.AND(sources, 1025) = 1025 OR Bit.AND(sources, 16777232) = 16777232 Then
			Name(Device_Index) = joDevice.RunMethod("getName", Null)
			Desc(Device_Index) = joDevice.RunMethod("getDescriptor" ,Null)
			Log("Device Index: " & Device_Index & CRLF & _
			    "Name: " & Name(Device_Index) & CRLF & _
				"Descriptor: " & Desc(Device_Index))				
			Device_Index = Device_Index + 1
		End If
	Next
	If Name(Min(Index, Name.Length - 1)) <> "" Then
		If Device_Descriptor = True Then
			Return Desc(Index)
		Else
			Return Name(Index)
		End If
	Else
		Log("No Gamepad or Joystick detected.")
		Return "No Gamepad or Joystick detected."
	End If
End Sub